<?php
/* BasicNav by Nimja.com
Snippet call: [[!BasicNav &sortBy=`publishedon` &sortDir=`ASC` &placeholder=`1`]]
Placeholder:  [[!+basicnav]]

Both MUST be uncached, otherwise pages in the middle would not know when a new last page is added.

Other options:
$firstTxt, $prevTxt, $nextTxt, $lastTxt <- Text of the links.
*/

// ---- Default Values forced.

$sortBy = !empty($sortBy) ? $sortBy : 'pub_date';
$sortHow = !empty($sortHow) ? $sortHow : 'ASC';
$placeholder = !empty($placeholder) ? $placeholder : TRUE;

$firstTxt = !empty($first) ? $first : '&lt;&lt;';
$prevTxt = !empty($prev) ? $prev : '&gt;';
$nextTxt = !empty($next) ? $next : '&lt;';
$lastTxt = !empty($last) ? $last : '&gt;&gt;';

// ---- Actual code 

//Get the parents (and verify)
$cur = $modx->resource->id;
$parent = $modx->resource->parent;
if (empty($parent)) {
	return 'No parent?';
	exit;
}

//Get the children.
$criteria = $modx->newQuery('modResource');
$criteria->where(array(
   'parent' => $parent,
   'hidemenu' => 0,
));
$criteria->sortby($sortBy,$sortHow);
$children = $modx->getCollection('modResource',$criteria);

$first = NULL;
$prev = NULL;
$next = NULL;
$last = NULL;

$seen = FALSE;
$now = FALSE;
foreach ($children as &$child) {
	//Check if this is the current child.
	$now = ($child->id == $cur);
	if ($now) $seen = TRUE;
	
	//First one is only set once.
	if (!$seen && empty($first)) $first = $child;
	//Prev is set until we meet our current.
	if (!$seen) $prev = $child;
	//Next is set once directly after the current.
	if ($seen && empty($next) && !$now) $next = $child; 
	//Set after we've seen stuff.
	if ($seen && !$now) $last = $child;
}
//Disable certain things at times.
if ($first == $prev) $first = NULL;
if ($last == $next) $last = NULL;

$result = '<div class="nav">';
$result .= empty($first) ? '<div></div>' : '<div><a href="[[~'.$first->id.']]" class="first" title="'.$first->pagetitle.'">'.$firstTxt.'</a></div>';
$result .= empty($prev) ? '<div></div>' : '<div><a href="[[~'.$prev->id.']]" class="prev" title="'.$prev->pagetitle.'">'.$prevTxt.'</a></div>';
$result .= empty($next) ? '<div></div>' : '<div><a href="[[~'.$next->id.']]" class="next" title="'.$next->pagetitle.'">'.$nextTxt.'</a></div>';
$result .= empty($last) ? '<div></div>' : '<div><a href="[[~'.$last->id.']]" class="last" title="'.$last->pagetitle.'">'.$lastTxt.'</a></div>';
$result .= '</div>';

if ($placeholder) {
	$modx->setPlaceholder('basicnav', $result);
	return;
} else {
	return $result;
}